/*********************************************
Project : Communication srie PPE accs de portail
Version : 1
Date    : 19/01/2004
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8535.h>
#include <stdio.h>

#define S1 PORTA.4
#define S2 PORTA.5

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here

void main(void)
{
// Declare your local variables here
unsigned char k;

PORTA=0xFF;
DDRA=0x00; 

// UART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// UART Receiver: On
// UART Transmitter: On
// UART Baud rate: 9600
UCR=0x18;
UBRR=0x19;

// LCD module initialization
lcd_init(16);

while (1)
      {
      	 k=getchar();
      	 lcd_putchar(k);
       	 putchar(k);
      };
}
